Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | Directories | File List | Namespace Members | Class Members | File Members | Related Pages

# TAO_Wait_On_Leader_Follower Class Reference

Wait according to the Leader-Follower model. Leader does the event loop of the Reactor and the Followers wait on the condition variable. More...

`#include <Wait_On_Leader_Follower.h>`

Inheritance diagram for TAO_Wait_On_Leader_Follower:

[legend]
Collaboration diagram for TAO_Wait_On_Leader_Follower:

[legend]
List of all members.

## Public Member Functions
| TAO_Wait_On_Leader_Follower (TAO_Transport *transport)
| Constructor.
virtual | ~TAO_Wait_On_Leader_Follower (void)
| Destructor.
virtual int | sending_request (TAO_ORB_Core *orb_core, int two_way)
virtual int | wait (ACE_Time_Value *max_wait_time, TAO_Synch_Reply_Dispatcher &rd)
virtual int | register_handler (void)
virtual bool | non_blocking (void) const
virtual bool | can_process_upcalls (void) const

## Detailed Description

Wait according to the Leader-Follower model. Leader does the event loop of the Reactor and the Followers wait on the condition variable.

This implementation is to work with the Muxed Transport Mechanism. Here the state variables such as <condition variable=""> etc cannot be kept in the Wait Strategy, since the Wait Strategy is per Transport object and here the Transport is Muxed and hence there are multiple threads running in the same Transport context.

## Constructor & Destructor Documentation

TAO_BEGIN_VERSIONED_NAMESPACE_DECL TAO_Wait_On_Leader_Follower::TAO_Wait_On_Leader_Follower | ( | TAO_Transport * | transport | ) |

| Constructor.

TAO_Wait_On_Leader_Follower::~TAO_Wait_On_Leader_Follower | ( | void |  | ) | `[virtual]`

| Destructor.

## Member Function Documentation

bool TAO_Wait_On_Leader_Follower::can_process_upcalls | ( | void |  | ) | const`[virtual]`

| This flag is to check whether the thread can process upcalls while waiting for the reply. Some wait strategies, like Wait_On_LF_No_Upcall does not allow the client threads to process requests while waiting for the reply. Implements TAO_Wait_Strategy. Reimplemented in TAO::Wait_On_LF_No_Upcall.

bool TAO_Wait_On_Leader_Follower::non_blocking | ( | void |  | ) | const`[virtual]`

| Returns a value to indicate whether the transport needs to set the socket on which it is waiting to non-blocking mode or not. Implements TAO_Wait_Strategy.

int TAO_Wait_On_Leader_Follower::register_handler | ( | void |  | ) | `[virtual]`

| Register the handler needs with the reactor provided that it makes sense for the strategy. Implements TAO_Wait_Strategy.

int TAO_Wait_On_Leader_Follower::sending_request | ( | TAO_ORB_Core * | orb_core,
|  | int | two_way
| ) | `[virtual]`

| The user is going to send a request, prepare any internal variables because the reply may arrive *before* the user calls wait. Reimplemented from TAO_Wait_Strategy.

int TAO_Wait_On_Leader_Follower::wait | ( | ACE_Time_Value * | max_wait_time,
|  | TAO_Synch_Reply_Dispatcher & | rd
| ) | `[virtual]`

| Base class virtual method. Wait till the `reply_received` flag is true or the time expires. Implements TAO_Wait_Strategy. Reimplemented in TAO::Wait_On_LF_No_Upcall.

The documentation for this class was generated from the following files:

- Wait_On_Leader_Follower.h
- Wait_On_Leader_Follower.cpp